/***********************************************************
  O kralovskom tkacovi
  Autor: Marian Varga, aug-2000
  uprava pre ucely sutaze na FEI 17-okt-2000
  zadanie: cloth.tex | cloth.ps
  matem.odvodenie: cloth_solution.gif
***********************************************************/

#include <stdio.h>
#define MAXL 10000

int l, n, l_cele;
int ff[MAXL]; /* "F(l,K)" */
int nn[MAXL+1]; /* kumulovany pocet kazov od zaciatku */

FILE *fin, *fout;

void nacitaj_kazy(void)
{
  int i, k, ki;

  nn[0]=0;
  i=1;
  for (k=0; k<n; k++)
  {
    fscanf(fin, "%d", &ki);
    for (; i<ki; i++)  nn[i]=k;
  }
  for (; i<=l; i++)  nn[i]=n;
}


int main(void)
{
  int k;
  int ffmax, ns, ls, ll, q, t, fs, ffs;
  int lmin, lsq, lsdif, dff;

  /*
  fin = fopen("latka.in", "r");
  fout = fopen("latka.out", "w");
  if (!fin || !fout) return 1;
  */
  fin=stdin; fout=stdout;

  fscanf(fin, "%d", &k);
  while (k--) {

  fscanf(fin, "%d%d", &l, &n);
  nacitaj_kazy();

  l_cele=l;

  ff[0]=0; /* F(0,K)=0 */
  for (l=1; l<=l_cele; l++)
  {
    /* urci F(l,K) */
    ffmax=0;

    for (ls=1; ls<=l; )
    {
      /* vypocitaj fi+FI... */

      ns = nn[l]-nn[l-ls];  /* pocet kazov pozdlz ls */

      /* vypocitaj fs=f(ls,ns)=fi */
      if (ls >= 50 && ns == 0) { t=5; fs=5*ls; } /* "K": t==5 */
      else if (ls < 10) { t=0; fs=0; }  /* "V": t==0 */
      else {
	ll=ls/10;  q=(ns+ll-1)/ll;
	if (ls >= 20 && q <= 1) { t=3; fs=3*ls; }  /* "S": t==3 */
	else if (ls >= 10 && q <= 3) { t=2; fs = 2*ls; } /* "P": t==2 */
	else { t=0; fs=0; }
      }

      ffs = fs + ff[l-ls];  /* ffs = fi + FI */

      if (ffs > ffmax) ffmax=ffs;

      /* urci inkrement ls */
      switch (t)
      {
	case 3:   /* S -> K */
	  q=0;
	  if (ns==0) lmin=50;
	  else lmin=l+1;
	  break;

	case 2:   /* P -> S */
	  q=1;
	  lmin=20;
	  break;

	case 0:   /* V -> P */
	  q=3;
	  lmin=10;
	  break;

	default:  /* K */
	  q=0;
	  lmin=l+1;
      }
      if (q) {
	lsq = (ns+q-1)/q * 10;
	if (lsq < lmin) lsq = lmin;
      }
      else lsq = lmin;
      /* lsq = ls + delta lsq */

      dff = ffmax - ffs + 1;   /* delta F */
      if (t)  lsdif = (dff+t-1)/t + ls;
      else lsdif = l+1;
      /* lsdif = ls + delta lsdif */

      ls = (lsdif < lsq) ? lsdif : lsq;
    }  /* for(ls) */

    ff[l] = ffmax;
  } /* for(l) */

  fprintf(fout, "%d\n", ff[l_cele]);

  }
  /**
  fclose(fout);
  fclose(fin);
  **/

  return 0;
}
