// O obrannych trojkach
// Autor: Peter Trebaticky

//        x1     x2:-4|-3|-2|-1| 0| 1| 2| 3| 4  (krat 1/2)
//        1           |  |  |  |01|  |  |  |
//        2           |  |  |02|  |03|  |  |
//        3           |  |04|  |05|  |06|  |
//        4           |07|  |08|  |09|  |10|
//        5         11|  |12|  |13|  |14|  |15
// (krat sqrt(3/4))
//
// Riesenie spociva v pretransformovani A, B, C na suradnice v rovine
// a porovnanim dlzok useciek AB, AC, BC.

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NOdebug

int main(void)
{
  FILE *fin,*fout;
  long A,B,C;
  long a1,a2,b1,b2,c1,c2;
  long dAB,dAC,dBC;

#ifdef debug
  fin=fopen("triples.in","rt");
  fout=fopen("triples.out","wt");
#else
  fin=stdin;
  fout=stdout;
#endif

  fscanf(fin,"%ld %ld %ld",&A,&B,&C);
  while(A+B+C!=0){
    a2=ceil((-1+sqrt(1+8*A))/2-0.00001);// pocet prvkov v riadku (tj. riadok)
    a1=A-(a2*(a2-1)/2);//pozicia v riadku zlava
    if(a2%2==0){
      a1=a1-a2/2;// odcitame polovicu riadka
      a1=a1*2-1; // vysledna suradnica v nasej ploche
    }else{
      a1=a1-(a2+1)/2;// odcitame polovicu riadka
      a1=a1*2;   // vysledna suradnica v nasej ploche
    }
    b2=ceil((-1+sqrt(1+8*B))/2-0.00001);// pocet prvkov v riadku (tj. riadok)
    b1=B-(b2*(b2-1)/2);//pozicia v riadku zlava
    if(b2%2==0){
      b1=b1-b2/2;// odcitame polovicu riadka
      b1=b1*2-1; // vysledna suradnica v nasej ploche
    }else{
      b1=b1-(b2+1)/2;// odcitame polovicu riadka
      b1=b1*2;   // vysledna suradnica v nasej ploche
    }
    c2=ceil((-1+sqrt(1+8*C))/2-0.00001);// pocet prvkov v riadku (tj. riadok)
    c1=C-(c2*(c2-1)/2);//pozicia v riadku zlava
    if(c2%2==0){
      c1=c1-c2/2;// odcitame polovicu riadka
      c1=c1*2-1; // vysledna suradnica v nasej ploche
    }else{
      c1=c1-(c2+1)/2;// odcitame polovicu riadka
      c1=c1*2;   // vysledna suradnica v nasej ploche
    }

    dAB=(a1-b1)*(a1-b1)+3*(a2-b2)*(a2-b2);
    dAC=(a1-c1)*(a1-c1)+3*(a2-c2)*(a2-c2);
    dBC=(b1-c1)*(b1-c1)+3*(b2-c2)*(b2-c2);

    if((dAB==dAC)&&(dAB==dBC)) // v tom je zahrnute aj dAC==dBC
      fprintf(fout,"YES\n");
        else fprintf(fout,"NO\n");

    fscanf(fin,"%ld %ld %ld",&A,&B,&C);
  }

#ifdef debug
  fclose(fout);
  fclose(fin);
#endif
  return 0;
}